#include "version.h"
#include "common.h"

#include "char.h"
#include "char_data.h"
#include "item.h"
#include "battle.h"
#include "object.h"
#ifdef _CAX_ADD_LUADX
#include "enemy.h"
#endif
//0-1999 CHAR_getInt
//2000-3999 CHAR_getChar
//4000-5999 CHAR_getWorkInt
//6000-7999 CHAR_getWorkChar
//8000-9999 CHAR_getFlg
#define LUA_DATALINE0 0
#define LUA_DATALINE1 2000
#define LUA_DATALINE2 4000
#define LUA_DATALINE3 6000
#define LUA_DATALINE4 8000
#define LUA_DATALINE5 10000

typedef struct __lua_const {
  const char *name;
  unsigned int size;
  int vl;
}lua_const;

lua_const M_Lua_RegConstList[] = {
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_DATAPLACENUMBER},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_BASEIMAGENUMBER},
	{"_ԭ%", sizeof("_ԭ%"), LUA_DATALINE0 + CHAR_BASEBASEIMAGENUMBER},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FACEIMAGENUMBER},
	{"_ͼ%", sizeof("_ͼ%"), LUA_DATALINE0 + CHAR_FLOOR},
	{"_X%", sizeof("_X%"), LUA_DATALINE0 + CHAR_X},
	{"_Y%", sizeof("_Y%"), LUA_DATALINE0 + CHAR_Y},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_DIR},
	{"_ȼ%", sizeof("_ȼ%"), LUA_DATALINE0 + CHAR_LV},
	{"_ʯ%", sizeof("_ʯ%"), LUA_DATALINE0 + CHAR_GOLD},
	{"_Ѫ%", sizeof("_Ѫ%"), LUA_DATALINE0 + CHAR_HP},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_MP},
	{"_M%", sizeof("_M%"), LUA_DATALINE0 + CHAR_MAXMP},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_VITAL},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_STR},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_TOUGH},
	{"_ٶ%", sizeof("_ٶ%"), LUA_DATALINE0 + CHAR_DEX},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_CHARM},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_LUCK},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_EARTHAT},
	{"_ˮ%", sizeof("_ˮ%"), LUA_DATALINE0 + CHAR_WATERAT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FIREAT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_WINDAT},
	{"_ս%", sizeof("_ս%"), LUA_DATALINE0 + CHAR_DEFAULTPET},
	{"_CL%", sizeof("_CL%"), LUA_DATALINE0 + CHAR_CRITIAL},
	{"_CR%", sizeof("_CR%"), LUA_DATALINE0 + CHAR_COUNTER},
	{"_ϡ%", sizeof("_ϡ%"), LUA_DATALINE0 + CHAR_RARE},
	{"_RH%", sizeof("_RH%"), LUA_DATALINE0 + CHAR_RADARSTRENGTH},
	{"_CE%", sizeof("_CE%"), LUA_DATALINE0 + CHAR_CHATVOLUME},
	{"_ML%", sizeof("_ML%"), LUA_DATALINE0 + CHAR_MERCHANTLEVEL},
	{"_¼%", sizeof("_¼%"), LUA_DATALINE0 + CHAR_SAVEPOINT},
	{"_DM%", sizeof("_DM%"), LUA_DATALINE0 + CHAR_DETERMINEITEM},
	{"_ƺ%", sizeof("_ƺ%"), LUA_DATALINE0 + CHAR_INDEXOFEQTITLE},
	{"_ƶ%", sizeof("_ƶ%"), LUA_DATALINE0 + CHAR_POISON},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_PARALYSIS},
	{"_Ĭ%", sizeof("_Ĭ%"), LUA_DATALINE0 + CHAR_SLEEP},
	{"_ʯ%", sizeof("_ʯ%"), LUA_DATALINE0 + CHAR_STONE},
	{"_ư%", sizeof("_ư%"), LUA_DATALINE0 + CHAR_DRUNK},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_CONFUSION},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_LOGINCOUNT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_DEADCOUNT},
	{"_ߴ%", sizeof("_ߴ%"), LUA_DATALINE0 + CHAR_WALKCOUNT},
	{"_˵%", sizeof("_˵%"), LUA_DATALINE0 + CHAR_TALKCOUNT},
	{"_˴%", sizeof("_˴%"), LUA_DATALINE0 + CHAR_DAMAGECOUNT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_GETPETCOUNT},
	{"_ɱ%", sizeof("_ɱ%"), LUA_DATALINE0 + CHAR_KILLPETCOUNT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_DEADPETCOUNT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_SENDMAILCOUNT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_MERGEITEMCOUNT},
	{"_PK%", sizeof("_PK%"), LUA_DATALINE0 + CHAR_DUELBATTLECOUNT},
	{"_PӮ%", sizeof("_PӮ%"), LUA_DATALINE0 + CHAR_DUELWINCOUNT},
	{"_P%", sizeof("_P%"), LUA_DATALINE0 + CHAR_DUELLOSECOUNT},
	{"_P%", sizeof("_P%"), LUA_DATALINE0 + CHAR_DUELSTWINCOUNT},
	{"_P%", sizeof("_P%"), LUA_DATALINE0 + CHAR_DUELMAXSTWINCOUNT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_WHICHTYPE},
	{"_Ƽ%", sizeof("_Ƽ%"), LUA_DATALINE0 + CHAR_WALKINTERVAL},
	{"_ѭʱ%", sizeof("_ѭʱ%"), LUA_DATALINE0 + CHAR_LOOPINTERVAL},
#ifdef _NEWOPEN_MAXEXP
	{"_ɾ%", sizeof("_ɾ%"), LUA_DATALINE0 + CHAR_OLDEXP},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_EXP},
#else
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_EXP},
#endif

#ifdef _CAX_ADD_LUADX
	{"_ѪMAX%", sizeof("_ѪMAX%"), LUA_DATALINE0 + CHAR_WORKMAXHP},
	{"_MAX%", sizeof("_MAX%"), LUA_DATALINE0 + CHAR_WORKMAXMP},
	{"_ͼ%", sizeof("_ͼ%"), LUA_DATALINE2 + CHAR_WORKFMFLOOR},
	{"_ɳ%", sizeof("_ɳ%"), LUA_DATALINE0 + CHAR_ALLOCPOINT},
	{"_PETRANK%", sizeof("_PETRANK%"), LUA_DATALINE0 + CHAR_PETRANK},
	{"_ENEMYBASE%", sizeof("_ENEMYBASE%"), LUA_DATALINE0 + CHAR_PETID},
	{"_̯%", sizeof("_̯%"), LUA_DATALINE0 + CHAR_WORKSTREETVENDOR},
	{"_̯%", sizeof("_̯%"), LUA_DATALINE0 + CHAR_WORKSTREETVENDOR_WHO},
	{"_̯%", sizeof("_̯%"), LUA_DATALINE0 + CHAR_STREETVENDOR_NAME},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_LOVE},
	{"_ż%", sizeof("_ż%"), LUA_DATALINE0 + CHAR_LOVERID},
	{"_ż%", sizeof("_ż%"), LUA_DATALINE0 + CHAR_LOVERNAME},
	{"ɳ_ٶ%", sizeof("ɳ_ٶ%"), 0},
	{"ɳ_%", sizeof("ɳ_%"), 1},
	{"ɳ_%", sizeof("ɳ_%"), 2},
	{"ɳ_%", sizeof("ɳ_%"), 3},
	{"_ٶȳɳ%", sizeof("_ٶȳɳ%"), 0},
	{"_ɳ%", sizeof("_ɳ%"), 1},
	{"_ɳ%", sizeof("_ɳ%"), 2},
	{"_ɳ%", sizeof("_ɳ%"), 3},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_TEMPNO},
	{"ģ_ʼ%", sizeof("ģ_ʼ%"), LUA_DATALINE0 + E_T_INITNUM},
	{"ģ_%", sizeof("ģ_%"), E_T_LVUPPOINT},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_BASEVITAL},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_BASESTR},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_BASETGH},
	{"ģ_ٶ%", sizeof("ģ_ٶ%"), LUA_DATALINE0 + E_T_BASEDEX},
	{"ģ_AI%", sizeof("ģ_AI%"), LUA_DATALINE0 + E_T_MODAI},
	{"ģ_GET%", sizeof("ģ_GET%"), LUA_DATALINE0 + E_T_GET},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_EARTHAT},
	{"ģ_ˮ%", sizeof("ģ_ˮ%"), LUA_DATALINE0 + E_T_WATERAT},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_FIREAT},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_WINDAT},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_POISON},
	{"ģ_鿹%", sizeof("ģ_鿹%"), LUA_DATALINE0 + E_T_PARALYSIS},
	{"ģ_Ĭ%", sizeof("ģ_Ĭ%"), LUA_DATALINE0 + E_T_SLEEP},
	{"ģ_ʯ%", sizeof("ģ_ʯ%"), LUA_DATALINE0 + E_T_STONE},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_DRUNK},
	{"ģ_ҿ%", sizeof("ģ_ҿ%"), LUA_DATALINE0 + E_T_CONFUSION},
	{"ģ_輼1%", sizeof("ģ_輼1%"), LUA_DATALINE0 + E_T_PETSKILL1},
	{"ģ_輼2%", sizeof("ģ_輼2%"), LUA_DATALINE0 + E_T_PETSKILL2},
	{"ģ_輼3%", sizeof("ģ_輼3%"), LUA_DATALINE0 + E_T_PETSKILL3},
	{"ģ_輼4%", sizeof("ģ_輼4%"), LUA_DATALINE0 + E_T_PETSKILL4},
	{"ģ_輼5%", sizeof("ģ_輼5%"), LUA_DATALINE0 + E_T_PETSKILL5},
	{"ģ_輼6%", sizeof("ģ_輼6%"), LUA_DATALINE0 + E_T_PETSKILL6},
	{"ģ_輼7%", sizeof("ģ_輼7%"), LUA_DATALINE0 + E_T_PETSKILL7},
	{"ģ_ϡ%", sizeof("ģ_ϡ%"), LUA_DATALINE0 + E_T_RARE},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_CRITICAL},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_COUNTER},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_SLOT},
	{"ģ_ͼ%", sizeof("ģ_ͼ%"), LUA_DATALINE0 + E_T_IMGNUMBER},
	{"ģ_FLG%", sizeof("ģ_FLG%"), LUA_DATALINE0 + E_T_PETFLG},
	{"ģ_ߴ%", sizeof("ģ_ߴ%"), LUA_DATALINE0 + E_T_SIZE},
	{"ģ_%", sizeof("ģ_%"), LUA_DATALINE0 + E_T_LIMITLEVEL},
	{"ģ_ں%", sizeof("ģ_ں%"), LUA_DATALINE0 + E_T_FUSIONCODE},
	{"ģ_ԭ%", sizeof("ģ_ԭ%"), LUA_DATALINE1 + E_T_NAME},
#endif

	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_LASTTALKELDER},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_SKILLUPPOINT},
	{"_LT%", sizeof("_LT%"), LUA_DATALINE0 + CHAR_LEVELUPPOINT},
	{"_ͼ%", sizeof("_ͼ%"), LUA_DATALINE0 + CHAR_IMAGETYPE},
	{"_CLR%", sizeof("_CLR%"), LUA_DATALINE0 + CHAR_NAMECOLOR},
	{"_ɫ%", sizeof("_ɫ%"), LUA_DATALINE0 + CHAR_POPUPNAMECOLOR},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_LASTTIMESETLUCK},
	{"_DP%", sizeof("_DP%"), LUA_DATALINE0 + CHAR_DUELPOINT},
	{"_ת%", sizeof("_ת%"), LUA_DATALINE0 + CHAR_TRANSMIGRATION},
	{"_ת%", sizeof("_ת%"), LUA_DATALINE0 + CHAR_TRANSEQUATION},
	{"_IA%", sizeof("_IA%"), LUA_DATALINE0 + CHAR_INITDATA},
	{"_ʱ%", sizeof("_ʱ%"), LUA_DATALINE0 + CHAR_SILENT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FMINDEX},
	{"_ְ%", sizeof("_ְ%"), LUA_DATALINE0 + CHAR_FMLEADERFLAG},
	{"_ؾ%", sizeof("_ؾ%"), LUA_DATALINE0 + CHAR_FMSPRITE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_BANKGOLD},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_RIDEPET},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_LEARNRIDE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_LIMITLEVEL},
#ifdef _PET_FUSION
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FUSIONCODE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FUSIONINDEX},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FUSIONRAISE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FUSIONBEIT},
	{"_ʱ%", sizeof("_ʱ%"), LUA_DATALINE0 + CHAR_FUSIONTIMELIMIT},
#endif
#ifdef _DEATH_CONTEND
	{"_ӱ%", sizeof("_ӱ%"), LUA_DATALINE0 + CHAR_PKLISTTEAMNUM},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_PKLISTLEADER},
#endif
#ifdef _PERSONAL_FAME
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FAME},
#endif
#ifdef _CAX_Mercenary
  {"_Ӷ%",       sizeof("_Ӷ%"), LUA_DATALINE0 + CHAR_MERCENARY},  //Ӷ
#endif
#ifdef _VIP_RIDE
	{"_VIP%", sizeof("_VIP%"), LUA_DATALINE0 + CHAR_VIPRIDE},
	{"_VIPʱ%", sizeof("_VIPʱ%"), LUA_DATALINE0 + CHAR_VIPTIME},
#endif
#ifdef _VIP_SERVER
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_AMPOINT},
#endif
#ifdef _EV_NUM
	{"_ܻ%", sizeof("_ܻ%"), LUA_DATALINE0 + CHAR_EVNUM},
#endif
  {"_%",     sizeof("_%"), LUA_DATALINE0 + CHAR_MISSIONTRAIN_NUM},
  {"_ʱ%", sizeof("_ʱ%"), LUA_DATALINE0 + CHAR_MISSIONTRAIN_TIME},
  {"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_MISSIONTRAIN_NUM}, // ܻ
  {"_%",       sizeof("_%"), LUA_DATALINE0 + CHAR_EVOLVE},
  {"_ʱ%",   sizeof("_ʱ%"), LUA_DATALINE0 + CHAR_ONLINE_TIME},
  {"_¥ʱ%",   sizeof("_¥ʱ%"), LUA_DATALINE0 + CHAR_FLOORDIFI_TIME},
  {"_Ʒ%",       sizeof("_Ʒ%"), LUA_DATALINE0 + CHAR_SUPER},
  {"_ƺŵȼ%",   sizeof("_ƺŵȼ%"), LUA_DATALINE0 + CHAR_TITLE_LV},
  {"_ƺʱ%",   sizeof("_ƺʱ%"), LUA_DATALINE0 + CHAR_TITLE_TIME},
  {"_ʱ%",   sizeof("_ʱ%"), LUA_DATALINE0 + CHAR_MISSION_TIME},

#ifdef _ATTACK_MAGIC
	{"_ħ%", sizeof("_ħ%"), LUA_DATALINE0 + CHAR_EARTH_EXP},
	{"_ˮħ%", sizeof("_ˮħ%"), LUA_DATALINE0 + CHAR_WATER_EXP},
	{"_ħ%", sizeof("_ħ%"), LUA_DATALINE0 + CHAR_FIRE_EXP},
	{"_ħ%", sizeof("_ħ%"), LUA_DATALINE0 + CHAR_WIND_EXP},
	{"_ħ%", sizeof("_ħ%"), LUA_DATALINE0 + CHAR_EARTH_RESIST},
	{"_ˮħ%", sizeof("_ˮħ%"), LUA_DATALINE0 + CHAR_WATER_RESIST},
	{"_ħ%", sizeof("_ħ%"), LUA_DATALINE0 + CHAR_FIRE_RESIST},
	{"_ħ%", sizeof("_ħ%"), LUA_DATALINE0 + CHAR_WIND_RESIST},
	{"_쾭%", sizeof("_쾭%"), LUA_DATALINE0 + CHAR_EARTH_ATTMAGIC_EXP},
	{"_ˮ쾭%", sizeof("_ˮ쾭%"), LUA_DATALINE0 + CHAR_WATER_ATTMAGIC_EXP},
	{"_쾭%", sizeof("_쾭%"), LUA_DATALINE0 + CHAR_FIRE_ATTMAGIC_EXP},
	{"_쾭%", sizeof("_쾭%"), LUA_DATALINE0 + CHAR_WIND_ATTMAGIC_EXP},
	{"_ؿ%", sizeof("_ؿ%"), LUA_DATALINE0 + CHAR_EARTH_DEFMAGIC_EXP},
	{"_ˮ%", sizeof("_ˮ%"), LUA_DATALINE0 + CHAR_WATER_DEFMAGIC_EXP},
	{"_𿹾%", sizeof("_𿹾%"), LUA_DATALINE0 + CHAR_FIRE_DEFMAGIC_EXP},
	{"_翹%", sizeof("_翹%"), LUA_DATALINE0 + CHAR_WIND_DEFMAGIC_EXP},
#endif
#ifdef _GAMBLE_BANK
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_PERSONAGOLD},
#endif
#ifdef _DROPSTAKENEW
	{"_ķ%", sizeof("_ķ%"), LUA_DATALINE0 + CHAR_GAMBLENUM},
#endif
#ifdef _AUCTIONEER
	{"_ĵ%", sizeof("_ĵ%"), LUA_DATALINE0 + CHAR_AUCGOLD},
#endif
#ifdef _PET_EVOLUTION
	{"_Ѫҩ%", sizeof("_Ѫҩ%"), LUA_DATALINE0 + CHAR_EVOLUTIONBASEVTL},
	{"_ҩ%", sizeof("_ҩ%"), LUA_DATALINE0 + CHAR_EVOLUTIONBASESTR},
	{"_ҩ%", sizeof("_ҩ%"), LUA_DATALINE0 + CHAR_EVOLUTIONBASETGH},
	{"_ҩ%", sizeof("_ҩ%"), LUA_DATALINE0 + CHAR_EVOLUTIONBASEDEX},
#endif
#ifdef _FAMILYBANKSTONELOG
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FMBANKGOLD},
#endif
#ifdef _FM_JOINLIMIT
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_FMTIMELIMIT},
#endif
#ifdef _CHAR_PROFESSION			// WON ADD ְҵ
	{"_ְҵ%", sizeof("_ְҵ%"), LUA_DATALINE0 + PROFESSION_CLASS},
	{"_ְ%", sizeof("_ְ%"), LUA_DATALINE0 + PROFESSION_LEVEL},
	//{"_ְ", sizeof("_ְ"), LUA_DATALINE0 + PROFESSION_EXP},
	{"_ְ%", sizeof("_ְ%"), LUA_DATALINE0 + PROFESSION_SKILL_POINT},
	{"_ְ%", sizeof("_ְ%"), LUA_DATALINE0 + ATTACHPILE},
	{"_ְ%", sizeof("_ְ%"), LUA_DATALINE0 + PROFESSION_FIRE_P},
	{"_ְ%", sizeof("_ְ%"), LUA_DATALINE0 + PROFESSION_ICE_P},
	{"_ְ%", sizeof("_ְ%"), LUA_DATALINE0 + PROFESSION_THUNDER_P},
	{"_ְ%", sizeof("_ְ%"), LUA_DATALINE0 + PROFESSION_FIRE_R},
	{"_ְ%", sizeof("_ְ%"), LUA_DATALINE0 + PROFESSION_ICE_R},
	{"_ְ׿%", sizeof("_ְ׿%"), LUA_DATALINE0 + PROFESSION_THUNDER_R},
#endif
#ifdef _ALLDOMAN // (ɿ) Syu ADD аNPC
	{"_ս%", sizeof("_ս%"), LUA_DATALINE0 + CHAR_HEROFLOOR},
#endif
#ifdef _PETSKILL_BECOMEPIG
	{"_ʱ%", sizeof("_ʱ%"), LUA_DATALINE0 + CHAR_BECOMEPIG},
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_BECOMEPIG_BBI},
#endif
	{"_ʱ%", sizeof("_ʱ%"), LUA_DATALINE0 + CHAR_LASTLEAVETIME},
#ifdef _NEW_MANOR_LAW
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_MOMENTUM},
#endif
#ifdef _ANGEL_SUMMON
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_HEROCNT},
#endif
#ifdef _TEACHER_SYSTEM
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_TEACHER_FAME},
#endif
#ifdef _CAX_ESC_REPORT
	{"_ǩ%", sizeof("_ǩ%"), LUA_DATALINE0 + CHAR_REPORT},
#endif
#ifdef _RACEMAN
	{"_CKN%", sizeof("_CKN%"), LUA_DATALINE0 + CHAR_CHECKIN},
	{"_CN1%", sizeof("_CN1%"), LUA_DATALINE0 + CHAR_CATCHCNT1},
	{"_CN2%", sizeof("_CN2%"), LUA_DATALINE0 + CHAR_CATCHCNT2},
	{"_CN3%", sizeof("_CN3%"), LUA_DATALINE0 + CHAR_CATCHCNT3},
	{"_CN4%", sizeof("_CN4%"), LUA_DATALINE0 + CHAR_CATCHCNT4},
	{"_CN5%", sizeof("_CN5%"), LUA_DATALINE0 + CHAR_CATCHCNT5},
	{"_KN1%", sizeof("_KN1%"), LUA_DATALINE0 + CHAR_KINDCNT1},
	{"_KN2%", sizeof("_KN2%"), LUA_DATALINE0 + CHAR_KINDCNT2},
	{"_KN3%", sizeof("_KN3%"), LUA_DATALINE0 + CHAR_KINDCNT3},
	{"_KN4%", sizeof("_KN4%"), LUA_DATALINE0 + CHAR_KINDCNT4},
	{"_KN5%", sizeof("_KN5%"), LUA_DATALINE0 + CHAR_KINDCNT5},
	{"_KN6%", sizeof("_KN6%"), LUA_DATALINE0 + CHAR_KINDCNT6},
	{"_KN7%", sizeof("_KN7%"), LUA_DATALINE0 + CHAR_KINDCNT7},
	{"_KN8%", sizeof("_KN8%"), LUA_DATALINE0 + CHAR_KINDCNT8},
	{"_KN9%", sizeof("_KN9%"), LUA_DATALINE0 + CHAR_KINDCNT9},
	{"_KN10%", sizeof("_KN10%"), LUA_DATALINE0 + CHAR_KINDCNT10},
#endif
  {"_ף%", sizeof("_ף%"), LUA_DATALINE0 + CHAR_BEATITUDE},
#ifdef	_VIGOR_SYS
	{"_%", sizeof("_%"), LUA_DATALINE0 + CHAR_VIGOR},
#endif
  {"_1%",   sizeof("_1%"), LUA_DATALINE0 + CHAR_LUASAVE_WORKINT_1},  //lua洢 
  {"_2%",   sizeof("_2%"), LUA_DATALINE0 + CHAR_LUASAVE_WORKINT_2},  //lua洢 
  {"_3%",   sizeof("_3%"), LUA_DATALINE0 + CHAR_LUASAVE_WORKINT_3},  //lua洢 
  {"_洢1%", sizeof("_洢1%"), LUA_DATALINE0 + CHAR_LUASAVE_INT_1},      //洢浵
  {"_洢2%", sizeof("_洢2%"), LUA_DATALINE0 + CHAR_LUASAVE_INT_2},      //洢浵
  {"_洢3%", sizeof("_洢3%"), LUA_DATALINE0 + CHAR_LUASAVE_INT_3},      //洢浵
 // {"_IP%",sizeof("_IP%"),LUA_DATALINE1 + CHAR_CHARPLAYIP},
 
  {"_Աȼ%", sizeof("_Աȼ%"), LUA_DATALINE0 + CHAR_VIPRIDE},
	{"_Աʱ%", sizeof("_Աʱ%"), LUA_DATALINE0 + CHAR_VIPTIME},
	
	{"_NPCʱ%", sizeof("_NPCʱ%"), LUA_DATALINE0 + CHAR_NPCTIME},

	{"_ԭ%", sizeof("_ԭ%"), LUA_DATALINE1 + CHAR_NAME},
	{"_%", sizeof("_%"), LUA_DATALINE1 + CHAR_USERPETNAME},
	{"_ʺ%", sizeof("_ʺ%"), LUA_DATALINE1 + CHAR_CDKEY},
	{"_%", sizeof("_%"), LUA_DATALINE1 + CHAR_OWNERCDKEY},
	{"_%", sizeof("_%"), LUA_DATALINE1 + CHAR_OWNERCHARANAME},
	{"_%", sizeof("_%"), LUA_DATALINE1 + CHAR_FMNAME},
#ifdef _TEACHER_SYSTEM
	{"_ʦ%", sizeof("_ʦ%"), LUA_DATALINE1 + CHAR_TEACHER_ID},
	{"_ʦ%", sizeof("_ʦ%"), LUA_DATALINE1 + CHAR_TEACHER_NAME},
#endif
#ifdef _CAX_LUA_BETT01
	{"_ս1%", sizeof("_ս1%"), LUA_DATALINE2 + CHAR_WORKBATTLECOM1},
	{"_ս2%", sizeof("_ս2%"), LUA_DATALINE2 + CHAR_WORKBATTLECOM2},
	{"_սģ%", sizeof("_սģ%"), LUA_DATALINE2 + CHAR_WORKBATTLEMODE},
#endif
	{"_ģʽ%", sizeof("_ģʽ%"), LUA_DATALINE2 + CHAR_WORKPARTYMODE},
	{"_%", sizeof("_%"), LUA_DATALINE2 + CHAR_WORKOBJINDEX},
#ifdef _ADD_ACTION          //npc
	{"_%", sizeof("_%"), LUA_DATALINE2 + CHAR_WORKACTION},
#endif
	{"_LUA%", sizeof("_LUA%"), LUA_DATALINE2 + CHAR_WORKLUANPCINT},
	{"_1LUA%", sizeof("_1LUA%"), LUA_DATALINE2 + CHAR_WORKLUANPCINT1},

	{"_IAK%", sizeof("_IAK%"), LUA_DATALINE4 + CHAR_ISATTACK},
	{"_ս%", sizeof("_ս%"), LUA_DATALINE4 + CHAR_ISATTACKED},
	{"_IOR%", sizeof("_IOR%"), LUA_DATALINE4 + CHAR_ISOVER},
	{"_·%", sizeof("_·%"), LUA_DATALINE4 + CHAR_ISOVERED},
	{"_HHT%", sizeof("_HHT%"), LUA_DATALINE4 + CHAR_HAVEHEIGHT},
	{"_%", sizeof("_%"), LUA_DATALINE4 + CHAR_ISVISIBLE},
	{"_ITP%", sizeof("_ITP%"), LUA_DATALINE4 + CHAR_ISTRANSPARENT},
	{"_IFG%", sizeof("_IFG%"), LUA_DATALINE4 + CHAR_ISFLYING},
	{"_%", sizeof("_%"), LUA_DATALINE4 + CHAR_ISDIE},
	{"_IBIG%", sizeof("_IBIG%"), LUA_DATALINE4 + CHAR_ISBIG},
	{"_ս%", sizeof("_ս%"), LUA_DATALINE4 + CHAR_ISSHOWBATTLEMSG},
	{"_ӱ%", sizeof("_ӱ%"), LUA_DATALINE4 + CHAR_ISPARTY},
	{"_%", sizeof("_%"), LUA_DATALINE4 + CHAR_ISWARP},
	{"_ս%", sizeof("_ս%"), LUA_DATALINE4 + CHAR_ISDUEL},
	{"_ı%", sizeof("_ı%"), LUA_DATALINE4 + CHAR_ISPARTYCHAT},
	{"_Ƭ%", sizeof("_Ƭ%"), LUA_DATALINE4 + CHAR_ISTRADECARD},
	{"_ױ%", sizeof("_ױ%"), LUA_DATALINE4 + CHAR_ISTRADE},
#ifdef _CHANNEL_MODIFY
	{"_Ƶ%", sizeof("_Ƶ%"), LUA_DATALINE4 + CHAR_ISTELL},
	{"_Ƶ%", sizeof("_Ƶ%"), LUA_DATALINE4 + CHAR_ISFM},
	{"_ְƵ%", sizeof("_ְƵ%"), LUA_DATALINE4 + CHAR_ISOCC},
	{"_Ի%", sizeof("_Ի%"), LUA_DATALINE4 + CHAR_ISSAVE},
	{"_Ƶ%", sizeof("_Ƶ%"), LUA_DATALINE4 + CHAR_ISCHAT},
#endif

	{"_ID%", sizeof("_ID%"), LUA_DATALINE0 + ITEM_ID},
	{"_ͼ%", sizeof("_ͼ%"), LUA_DATALINE0 + ITEM_BASEIMAGENUMBER},
	{"_ɱ%", sizeof("_ɱ%"), LUA_DATALINE0 + ITEM_COST},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_TYPE},
	{"_AUF%", sizeof("_AUF%"), LUA_DATALINE0 + ITEM_ABLEUSEFIELD},
	{"_TARGET%", sizeof("_TARGET%"), LUA_DATALINE0 + ITEM_TARGET},
	{"_ȼ%", sizeof("_ȼ%"), LUA_DATALINE0 + ITEM_LEVEL},
#ifdef _ITEM_MAXUSERNUM
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_DAMAGEBREAK},
#endif
#ifdef _ITEMSET4_TXT
	{"_ѵ%", sizeof("_ѵ%"), LUA_DATALINE0 + ITEM_USEPILENUMS},
	{"_ɵ%", sizeof("_ɵ%"), LUA_DATALINE0 + ITEM_CANBEPILE},
	{"_STR%", sizeof("_STR%"), LUA_DATALINE0 + ITEM_NEEDSTR},
	{"_DEX%", sizeof("_DEX%"), LUA_DATALINE0 + ITEM_NEEDDEX},
	{"_ת%", sizeof("_ת%"), LUA_DATALINE0 + ITEM_NEEDTRANS},
	{"_ְҵ%", sizeof("_ְҵ%"), LUA_DATALINE0 + ITEM_NEEDPROFESSION},
#endif
#ifdef _TAKE_ITEMDAMAGE
	{"_;%", sizeof("_;%"), LUA_DATALINE0 + ITEM_DAMAGECRUSHE},
	{"_MAX;%", sizeof("_MAX;%"), LUA_DATALINE0 + ITEM_MAXDAMAGECRUSHE},
#endif
#ifdef _ADD_DEAMGEDEFC
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_OTHERDAMAGE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_OTHERDEFC},
#endif
#ifdef _SUIT_ITEM
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_SUITCODE},
#endif
	{"_AKMIN%", sizeof("_AKMIN%"), LUA_DATALINE0 + ITEM_ATTACKNUM_MIN},
	{"_AKMAX%", sizeof("_AKMAX%"), LUA_DATALINE0 + ITEM_ATTACKNUM_MAX},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYATTACK},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYDEFENCE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYQUICK},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYHP},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYMP},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYLUCK},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYCHARM},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYAVOID},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYATTRIB},
	{"_ֵ%", sizeof("_ֵ%"), LUA_DATALINE0 + ITEM_MODIFYATTRIBVALUE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MAGICID},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MAGICPROB},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MAGICUSEMP},
#ifdef _ITEMSET5_TXT
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYARRANGE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MODIFYSEQUENCE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_ATTACHPILE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_HITRIGHT},
#endif
#ifdef _ITEMSET6_TXT
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_NEGLECTGUARD},
#endif
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_POISON},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_PARALYSIS},
	{"_˯%", sizeof("_˯%"), LUA_DATALINE0 + ITEM_SLEEP},
	{"_ʯ%", sizeof("_ʯ%"), LUA_DATALINE0 + ITEM_STONE},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_DRUNK},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_CONFUSION},
	{"_һ%", sizeof("_һ%"), LUA_DATALINE0 + ITEM_CRITICAL},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_USEACTION},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_DROPATLOGOUT},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_VANISHATDROP},
	{"_·%", sizeof("_·%"), LUA_DATALINE0 + ITEM_ISOVERED},
	{"_ʼ%", sizeof("_ʼ%"), LUA_DATALINE0 + ITEM_CANPETMAIL},
	{"_Ӻϳ%", sizeof("_Ӻϳ%"), LUA_DATALINE0 + ITEM_CANMERGEFROM},
	{"_ϳɵ%", sizeof("_ϳɵ%"), LUA_DATALINE0 + ITEM_CANMERGETO},
	{"_0%", sizeof("_0%"), LUA_DATALINE0 + ITEM_INGVALUE0},
	{"_1%", sizeof("_1%"), LUA_DATALINE0 + ITEM_INGVALUE1},
	{"_2%", sizeof("_2%"), LUA_DATALINE0 + ITEM_INGVALUE2},
	{"_3%", sizeof("_3%"), LUA_DATALINE0 + ITEM_INGVALUE3},
	{"_4%", sizeof("_4%"), LUA_DATALINE0 + ITEM_INGVALUE4},
	{"_ʱ%", sizeof("_ʱ%"), LUA_DATALINE0 + ITEM_PUTTIME},
	{"_LL%", sizeof("_LL%"), LUA_DATALINE0 + ITEM_LEAKLEVEL},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_MERGEFLG},
	{"_%", sizeof("_%"), LUA_DATALINE0 + ITEM_CRUSHLEVEL},
	{"_ʱ%", sizeof("_ʱ%"), LUA_DATALINE0 + ITEM_TIME},
	{"_VAR1%", sizeof("_VAR1%"), LUA_DATALINE0 + ITEM_VAR1},
	{"_VAR2%", sizeof("_VAR2%"), LUA_DATALINE0 + ITEM_VAR2},
	{"_VAR3%", sizeof("_VAR3%"), LUA_DATALINE0 + ITEM_VAR3},
	{"_VAR4%", sizeof("_VAR4%"), LUA_DATALINE0 + ITEM_VAR4},

	{"_%", sizeof("_%"), LUA_DATALINE2 + ITEM_WORKOBJINDEX},
	{"_%", sizeof("_%"), LUA_DATALINE2 + ITEM_WORKCHARAINDEX},
#ifdef _ITEM_TIME_LIMIT
	{"_ʱ%", sizeof("_ʱ%"), LUA_DATALINE2 + ITEM_WORKTIMELIMIT},
#endif

	{"_ԭ%", sizeof("_ԭ%"), LUA_DATALINE1 + ITEM_NAME},
	{"_%", sizeof("_%"), LUA_DATALINE1 + ITEM_SECRETNAME},
	{"_˵%", sizeof("_˵%"), LUA_DATALINE1 + ITEM_EFFECTSTRING},
	{"_%", sizeof("_%"), LUA_DATALINE1 + ITEM_ARGUMENT},
	{"_%", sizeof("_%"), LUA_DATALINE1 + ITEM_CDKEY},
	{"_%", sizeof("_%"), LUA_DATALINE1 + ITEM_FORUSERCDKEY},
	{"_0%", sizeof("_0%"), LUA_DATALINE1 + ITEM_INGNAME0},
	{"_1%", sizeof("_1%"), LUA_DATALINE1 + ITEM_INGNAME1},
	{"_2%", sizeof("_2%"), LUA_DATALINE1 + ITEM_INGNAME2},
	{"_3%", sizeof("_3%"), LUA_DATALINE1 + ITEM_INGNAME3},
	{"_4%", sizeof("_4%"), LUA_DATALINE1 + ITEM_INGNAME4},

	{"_ͷλ%", sizeof("_ͷλ%"), CHAR_HEAD},
	{"_λ%", sizeof("_λ%"), CHAR_BODY},
	{"_%", sizeof("_%"), CHAR_ARM},
	{"_1%", sizeof("_1%"), CHAR_DECORATION1},
	{"_2%", sizeof("_2%"), CHAR_DECORATION2},
#ifdef _ITEM_EQUITSPACE
	{"_%", sizeof("_%"), CHAR_EQSHIELD},
	{"_λ%", sizeof("_λ%"), CHAR_EQBELT},
	{"_λ%", sizeof("_λ%"), CHAR_EQSHOES},
#endif
#ifdef _EQUIT_NEWGLOVE
	{"_%", sizeof("_%"), CHAR_EQGLOVE},
#endif
	{"_1%", sizeof("_1%"), CHAR_STARTITEMARRAY + 0},
	{"_2%", sizeof("_2%"), CHAR_STARTITEMARRAY + 1},
	{"_3%", sizeof("_3%"), CHAR_STARTITEMARRAY + 2},
	{"_4%", sizeof("_4%"), CHAR_STARTITEMARRAY + 3},
	{"_5%", sizeof("_5%"), CHAR_STARTITEMARRAY + 4},
	{"_6%", sizeof("_6%"), CHAR_STARTITEMARRAY + 5},
	{"_7%", sizeof("_7%"), CHAR_STARTITEMARRAY + 6},
	{"_8%", sizeof("_8%"), CHAR_STARTITEMARRAY + 7},
	{"_9%", sizeof("_9%"), CHAR_STARTITEMARRAY + 8},
	{"_10%", sizeof("_10%"), CHAR_STARTITEMARRAY + 9},
	{"_11%", sizeof("_11%"), CHAR_STARTITEMARRAY + 10},
	{"_12%", sizeof("_12%"), CHAR_STARTITEMARRAY + 11},
	{"_13%", sizeof("_13%"), CHAR_STARTITEMARRAY + 12},
	{"_14%", sizeof("_14%"), CHAR_STARTITEMARRAY + 13},
	{"_15%", sizeof("_15%"), CHAR_STARTITEMARRAY + 14},

	{"_1%", sizeof("_1%"), 0},
	{"_2%", sizeof("_2%"), 1},
	{"_3%", sizeof("_3%"), 2},
	{"_4%", sizeof("_4%"), 3},
	{"_5%", sizeof("_5%"), 4},
	
	{"Ա_1%", sizeof("Ա_1%"), 1},
	{"Ա_2%", sizeof("Ա_2%"), 2},
	{"Ա_3%", sizeof("Ա_3%"), 3},
	{"Ա_4%", sizeof("Ա_4%"), 4},

	{"IT_צ%", sizeof("IT_צ%"), ITEM_FIST},
	{"IT_ͷ%", sizeof("IT_ͷ%"), ITEM_AXE},
	{"IT_%", sizeof("IT_%"), ITEM_CLUB},
	{"IT_ǹ%", sizeof("IT_ǹ%"), ITEM_SPEAR},
	{"IT_%", sizeof("IT_%"), ITEM_BOW},
	{"IT_SHIELD%", sizeof("IT_SHIELD%"), ITEM_SHIELD},
	{"IT_HELM%", sizeof("IT_HELM%"), ITEM_HELM},
	{"IT_ARMOUR%", sizeof("IT_ARMOUR%"), ITEM_ARMOUR},
	{"IT_ֻ%", sizeof("IT_ֻ%"), ITEM_BRACELET},
	{"IT_%", sizeof("IT_%"), ITEM_MUSIC},
	{"IT_%", sizeof("IT_%"), ITEM_NECKLACE},
	{"IT_%", sizeof("IT_%"), ITEM_RING},
	{"IT_BELT%", sizeof("IT_BELT%"), ITEM_BELT},
	{"IT_%", sizeof("IT_%"), ITEM_EARRING},
	{"IT_ǻ%", sizeof("IT_ǻ%"), ITEM_NOSERING},
	{"IT_%", sizeof("IT_%"), ITEM_AMULET},
	{"IT_%", sizeof("IT_%"), ITEM_OTHER},
	{"IT_%", sizeof("IT_%"), ITEM_BOOMERANG},
	{"IT_Ͷ%", sizeof("IT_Ͷ%"), ITEM_BOUNDTHROW},
	{"IT_Ͷʯ%", sizeof("IT_Ͷʯ%"), ITEM_BREAKTHROW},
	{"IT_DISH%", sizeof("IT_DISH%"), ITEM_DISH},
#ifdef _ITEM_INSLAY
	{"IT_%", sizeof("IT_%"), ITEM_METAL},
	{"IT_%", sizeof("IT_%"), ITEM_JEWEL},
#endif
#ifdef _ITEM_CHECKWARES
	{"IT_%", sizeof("IT_%"), ITEM_WARES},
#endif
#ifdef _ITEM_EQUITSPACE
	{"IT_%", sizeof("IT_%"), ITEM_WBELT},
	{"IT_%", sizeof("IT_%"), ITEM_WSHIELD},
	{"IT_Ь%", sizeof("IT_Ь%"), ITEM_WSHOES},
#endif
#ifdef _EQUIT_NEWGLOVE 
	{"IT_%", sizeof("IT_%"), ITEM_WGLOVE},
#endif
#ifdef _JZ_PETEQU
	{"IT_ͷ%", sizeof("IT_ͷ%"), ITEM_PET_HEAD},
	{"IT_%", sizeof("IT_%"), ITEM_PET_WING},
	{"IT_%", sizeof("IT_%"), ITEM_PET_TOOTH},
	{"IT_ؼ%", sizeof("IT_ؼ%"), ITEM_PET_BREAST},
	{"IT_豳%", sizeof("IT_豳%"), ITEM_PET_BACK},
	{"IT_צ%", sizeof("IT_צ%"), ITEM_PET_CLAW},
	{"IT_軤2%", sizeof("IT_軤2%"), ITEM_PET_FEET},
	{"IT_軤4%", sizeof("IT_軤4%"), ITEM_PET_FEET4},
	{"IT_%", sizeof("IT_%"), ITEM_PET_FIN},
#endif

	{"_û%", sizeof("_û%"), FMMEMBER_NONE},
	{"_һ%", sizeof("_һ%"), FMMEMBER_MEMBER},
	{"_%", sizeof("_%"), FMMEMBER_APPLY},
	{"_峤%", sizeof("_峤%"), FMMEMBER_LEADER},
	{"_%", sizeof("_%"), FMMEMBER_ELDER},
	//{"_˾", sizeof("_˾"), FMMEMBER_INVITE},
	//{"_", sizeof("_"), FMMEMBER_BAILEE},
	//{"_", sizeof("_"), FMMEMBER_VICELEADER},

	{"ս_%", sizeof("ս_%"), BATTLE_TYPE_NONE},
	{"ս_˹%", sizeof("ս_˹%"), BATTLE_TYPE_P_vs_E},
	{"ս_%", sizeof("ս_%"), BATTLE_TYPE_P_vs_P},
	{"ս_ֹ%", sizeof("ս_ֹ%"), BATTLE_TYPE_E_vs_E},
	{"ս_%", sizeof("ս_%"), BATTLE_TYPE_WATCH},
	{"ս_DP%", sizeof("ս_DP%"), BATTLE_TYPE_DP_BATTLE},
	{"ս_BOSS%", sizeof("ս_BOSS%"), BATTLE_TYPE_BOSS_BATTLE},

	{"ս_%", sizeof("ս_%"), BATTLE_MODE_NONE},
	{"ս_%", sizeof("ս_%"), BATTLE_MODE_INIT},
	{"ս_%", sizeof("ս_%"), BATTLE_MODE_BATTLE},
	{"ս_%", sizeof("ս_%"), BATTLE_MODE_FINISH},
	{"ս_%", sizeof("ս_%"), BATTLE_MODE_STOP},
	{"ս_۳%", sizeof("ս_۳%"), BATTLE_MODE_WATCHBC},
	{"ս_1%", sizeof("ս_1%"), BATTLE_MODE_WATCHPRE},
	{"ս_2%", sizeof("ս_2%"), BATTLE_MODE_WATCHWAIT},
	{"ս_3%", sizeof("ս_3%"), BATTLE_MODE_WATCHMOVIE},
	{"ս_4%", sizeof("ս_4%"), BATTLE_MODE_WATCHAFTER},

	{"Ů%", sizeof("Ů%"), CHAR_IMAGETYPE_GIRL},
	{"к%", sizeof("к%"), CHAR_IMAGETYPE_BOY},
	{"ͯ%", sizeof("ͯ%"), CHAR_IMAGETYPE_CHILDBOY},
	{"Ůͯ%", sizeof("Ůͯ%"), CHAR_IMAGETYPE_CHILDGIRL},
	{"%", sizeof("%"), CHAR_IMAGETYPE_MAN},
	{"Ů%", sizeof("Ů%"), CHAR_IMAGETYPE_WOMAN},
	{"%", sizeof("%"), CHAR_IMAGETYPE_OLDMAN},
	{"%", sizeof("%"), CHAR_IMAGETYPE_DOG},

	{"_%", sizeof("_%"), CHAR_TYPEPLAYER},
	{"_%", sizeof("_%"), CHAR_TYPEENEMY},
	{"_%", sizeof("_%"), CHAR_TYPEPET},
	{"_NPC1%", sizeof("_NPC1%"), CHAR_TYPEDOOR},
	{"_NPC2%", sizeof("_NPC2%"), CHAR_TYPEBOX},
	{"_NPC3%", sizeof("_NPC3%"), CHAR_TYPEMSG},
	{"_NPC4%", sizeof("_NPC4%"), CHAR_TYPEWARP},
	{"_NPC5%", sizeof("_NPC5%"), CHAR_TYPESHOP},
	{"_NPC6%", sizeof("_NPC6%"), CHAR_TYPEHEALER},
	{"_NPC7%", sizeof("_NPC7%"), CHAR_TYPEOLDMAN},
	{"_NPC8%", sizeof("_NPC8%"), CHAR_TYPEROOMADMIN},
	{"_NPC9%", sizeof("_NPC9%"), CHAR_TYPETOWNPEOPLE},
	{"_NPC10%", sizeof("_NPC10%"), CHAR_TYPEDENGON},
	{"_NPC11%", sizeof("_NPC11%"), CHAR_TYPEADM},
	{"_NPC12%", sizeof("_NPC12%"), CHAR_TYPETEMPLE},
	{"_NPC13%", sizeof("_NPC13%"), CHAR_TYPESTORYTELLER},
	{"_NPC14%", sizeof("_NPC14%"), CHAR_TYPERANKING},
	{"_NPC15%", sizeof("_NPC15%"), CHAR_TYPEOTHERNPC},
	{"_NPC16%", sizeof("_NPC16%"), CHAR_TYPEPRINTPASSMAN},
	{"_NPC17%", sizeof("_NPC17%"), CHAR_TYPENPCENEMY},
	{"_NPC18%", sizeof("_NPC18%"), CHAR_TYPEACTION},
	{"_NPC19%", sizeof("_NPC19%"), CHAR_TYPEWINDOWMAN},
	{"_NPC20%", sizeof("_NPC20%"), CHAR_TYPESAVEPOINT},
	{"_NPC21%", sizeof("_NPC21%"), CHAR_TYPEWINDOWHEALER},
	{"_NPC22%", sizeof("_NPC22%"), CHAR_TYPEITEMSHOP},
	{"_NPC23%", sizeof("_NPC23%"), CHAR_TYPESTONESHOP},
	{"_NPC24%", sizeof("_NPC24%"), CHAR_TYPEDUELRANKING},
	{"_NPC25%", sizeof("_NPC25%"), CHAR_TYPEWARPMAN},
	{"_NPC26%", sizeof("_NPC26%"), CHAR_TYPEEVENT},
	{"_NPC27%", sizeof("_NPC27%"), CHAR_TYPEMIC},
	{"_NPC28%", sizeof("_NPC28%"), CHAR_TYPELUCKYMAN},
	{"_NPC29%", sizeof("_NPC29%"), CHAR_TYPEBUS},
	{"_NPC30%", sizeof("_NPC30%"), CHAR_TYPECHARM},
	{"_NPC31%", sizeof("_NPC31%"), CHAR_TYPECHECKMAN},
	{"_NPC32%", sizeof("_NPC32%"), CHAR_TYPEJANKEN},
	{"_NPC33%", sizeof("_NPC33%"), CHAR_TYPETRANSMIGRATION},
	{"_NPC34%", sizeof("_NPC34%"), CHAR_TYPEFMWARPMAN},
	{"_NPC35%", sizeof("_NPC35%"), CHAR_TYPEFMSCHEDULEMAN},
	{"_NPC36%", sizeof("_NPC36%"), CHAR_TYPEMANORSCHEDULEMAN},
#ifdef _SERVICE
	{"_NPC37%", sizeof("_NPC37%"), CHAR_TYPESTONESERVICEMAN},
#endif
#ifdef _GAMBLE_BANK
	{"_NPC38%", sizeof("_NPC38%"), CHAR_GAMBLEBANK},
#endif
#ifdef _NEW_WARPMAN
	{"_NPC39%", sizeof("_NPC39%"), CHAR_NEWNPCMAN},
#endif
#ifdef _MARKET_TRADE
	{"_NPC40%", sizeof("_NPC40%"), CHAR_MAPTRADEMAN},
#endif
#ifdef _GAMBLE_ROULETTE
	{"_NPC41%", sizeof("_NPC41%"), CHAR_GAMBLEROULETTE},
	{"_NPC42%", sizeof("_NPC42%"), CHAR_GAMBLEMASTER},
#endif
#ifdef _TRANSER_MAN
	{"_NPC43%", sizeof("_NPC43%"), CHAR_TRANSERMANS},
#endif
#ifdef _JZ_NEW_ADDMEMBERPOINT
	{"_NPC44%", sizeof("_NPC44%"), CHAR_MEMBERMANS},
#endif
#ifdef _NPC_SELLSTH
	{"_NPC45%", sizeof("_NPC45%"), CHAR_SELLSTHMAN},
#endif
#ifdef _NPC_MAKEPAIR
	{"_NPC46%", sizeof("_NPC46%"), CHAR_MAKEPAIR},
#endif
#ifdef _NPC_FUSION
	{"_NPC47%", sizeof("_NPC47%"), CHAR_PETFUSIONMAN},
#endif
#ifdef _PAUCTION_MAN
	{"_NPC48%", sizeof("_NPC48%"), CHAR_PAUCTIONMAN},
#endif
#ifdef _ITEM_NPCCHANGE
	{"_NPC49%", sizeof("_NPC49%"), CHAR_ITEMCHANGENPC},
#endif
#ifdef _CFREE_petskill
	{"_NPC50%", sizeof("_NPC50%"), CHAR_FREESKILLSHOP},
#endif
#ifdef _PETRACE
	{"_NPC51%", sizeof("_NPC51%"), CHAR_PETRACEMASTER},
	{"_NPC52%", sizeof("_NPC52%"), CHAR_PETRACEPET},
#endif
#ifdef _AUCTIONEER
	{"_NPC53%", sizeof("_NPC53%"), CHAR_TYPEAUCTIONEER},
#endif
#ifdef _ALLDOMAN // (ɿ) Syu ADD аNPC
	{"_NPC54%", sizeof("_NPC54%"), CHAR_TYPEALLDOMAN},
#endif
	{"_NPC55%", sizeof("_NPC55%"), CHAR_TYPEPETMAKER},
#ifdef _NPC_WELFARE
	{"_NPC56%", sizeof("_NPC56%"), CHAR_TYPEWELFARE},
#endif
#ifdef _NPC_VERYWELFARE
	{"_NPC57%", sizeof("_NPC57%"), CHAR_TYPEVERYWELFARE},
#endif
#ifdef _NPC_WELFARE_2				// WON ADD ְҵNPC-2
	{"_NPC58%", sizeof("_NPC58%"), CHAR_TYPEWELFARE2},
#endif
#ifdef _RACEMAN
	{"_NPC59%", sizeof("_NPC59%"), CHAR_RACEMAN},
#endif

	{"_û%", sizeof("_û%"), OBJTYPE_NOUSE},
	{"_%", sizeof("_%"), OBJTYPE_CHARA},
	{"_%", sizeof("_%"), OBJTYPE_ITEM},
	{"_%", sizeof("_%"), OBJTYPE_GOLD},
#ifdef _NPCSERVER_NEW
	{"_NPC%", sizeof("_NPC%"), OBJTYPE_NPCSCHARA},
#endif
#ifdef _MAP_WARPPOINT
	{"_%", sizeof("_%"), OBJTYPE_WARPPOINT},
#endif

	{"ť_û%", sizeof("ť_û%"), WINDOW_BUTTONTYPE_NONE},
	{"ť_ȷ%", sizeof("ť_ȷ%"), WINDOW_BUTTONTYPE_OK},
	{"ť_ر%", sizeof("ť_ر%"), WINDOW_BUTTONTYPE_CANCEL},
	{"ť_%", sizeof("ť_%"), WINDOW_BUTTONTYPE_YES},
	{"ť_%", sizeof("ť_%"), WINDOW_BUTTONTYPE_NO},
	{"ť_һҳ%", sizeof("ť_һҳ%"), WINDOW_BUTTONTYPE_PREV},
	{"ť_һҳ%", sizeof("ť_һҳ%"), WINDOW_BUTTONTYPE_NEXT},

	{"_û%", sizeof("_û%"), CHAR_PARTY_NONE},
	{"_ӳ%", sizeof("_ӳ%"), CHAR_PARTY_LEADER},
	{"_Ա%", sizeof("_Ա%"), CHAR_PARTY_CLIENT},

	{"%", sizeof("%"), 0},
	{"%", sizeof("%"), 1},
	{"%", sizeof("%"), 2},
	{"%", sizeof("%"), 3},
	{"%", sizeof("%"), 4},
	{"%", sizeof("%"), 5},
	{"%", sizeof("%"), 6},
	{"%", sizeof("%"), 7},

	{"ɫ%", sizeof("ɫ%"), CHAR_COLORWHITE},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORCYAN},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORPURPLE},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORBLUE},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORYELLOW},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORGREEN},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORRED},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORGRAY},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORBLUE2},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORGREEN2},
	{"ɫ%", sizeof("ɫ%"), CHAR_COLORBLACK},

	{"Ӹ_OBJ%", sizeof("Ӹ_OBJ%"), CHAR_N_STRING_OBJINDEX},
	{"Ӹ_LV%", sizeof("Ӹ_LV%"), CHAR_N_STRING_LV},
	{"Ӹ_MAXHP%", sizeof("Ӹ_MAXHP%"), CHAR_N_STRING_MAXHP},
	{"Ӹ_HP%", sizeof("Ӹ_HP%"), CHAR_N_STRING_HP},
	{"Ӹ_MP%", sizeof("Ӹ_MP%"), CHAR_N_STRING_MP},
	{"Ӹ_%", sizeof("Ӹ_%"), CHAR_N_STRING_NAME},
	
	{"3_HP%", sizeof("3_HP%"), CHAR_P_STRING_HP},
	{"3_MAXHP%", sizeof("3_MAXHP%"), CHAR_P_STRING_MAXHP},
	{"3_MP%", sizeof("3_MP%"), CHAR_P_STRING_MP},
	{"3_MAXMP%", sizeof("3_MAXMP%"), CHAR_P_STRING_MAXMP},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_VITAL},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_STR},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_TOUGH},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_DEX},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_EXP},
	{"3_һ%", sizeof("3_һ%"), CHAR_P_STRING_NEXTEXP},
	{"3_ȼ%", sizeof("3_ȼ%"), CHAR_P_STRING_LV},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_ATK},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_DEF},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_QUICK},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_CHARM},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_LUCK},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_EARTH},
	{"3_ˮ%", sizeof("3_ˮ%"), CHAR_P_STRING_WATER},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_FIRE},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_WIND},
	{"3_ʯ%", sizeof("3_ʯ%"), CHAR_P_STRING_GOLD},
	{"3_ƺ%", sizeof("3_ƺ%"), CHAR_P_STRING_TITLE},
	{"3_DP%", sizeof("3_DP%"), CHAR_P_STRING_DUELPOINT},
	{"3_ת%", sizeof("3_ת%"), CHAR_P_STRING_TRANSMIGRATION},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_NAME},
	{"3_ǳ%", sizeof("3_ǳ%"), CHAR_P_STRING_OWNTITLE},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_RIDEPET},
	{"3_ѧȼ%", sizeof("3_ѧȼ%"), CHAR_P_STRING_LEARNRIDE},
	{"3_%", sizeof("3_%"), CHAR_P_STRING_BASEBASEIMAGENUMBER},
	{"3_ģʽ%", sizeof("3_ģʽ%"), CHAR_P_STRING_SKYWALKER},
	{"3_ģʽ%", sizeof("3_ģʽ%"), CHAR_P_STRING_DEBUGMODE},

	{NULL, 0, 0},
};

