#ifndef __NPC_LUA__
#define __NPC_LUA__

#include "npc_lua_interface.h"
#include "../lua/lua.h"
#include "../lua/lauxlib.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define LUA_DATALINE0 0
#define LUA_DATALINE1 2000
#define LUA_DATALINE2 4000
#define LUA_DATALINE3 6000
#define LUA_DATALINE4 8000
#define LUA_DATALINE5 10000

typedef struct __CREATEENEMY
{
	int EnemyId;
	int BaseLevel;
	int SkillType;
}CREATEENEMY,*PCREATEENEMY;

typedef struct __SCRIPTREGLIB
{
	const char *LibName;				//
	luaL_reg *FuncRegList;			//Ҫעĺ⺯б
}SCRIPTREGLIB,*PSCRIPTREGLIB;

typedef struct __SCRIPTREGCLASS
{
	const char *ClassName;			//
	PSCRIPTREGLIB NewLib;				//ʵ SCRIPTREGLIB
	luaL_reg *FuncRegList;			//Ҫעຯб
}SCRIPTREGCLASS,*PSCRIPTREGCLASS;

typedef struct __SCRIPTREGARRAY
{
	const char *ArrayName;			//
	const char **SetMetaTable;	//Ӧ
	const char **SetFuncName;		//Ӧĺ
	PSCRIPTREGLIB FuncList;			//ӦӦ SetMetaTable Ĵб
}SCRIPTREGARRAY,*PSCRIPTREGARRAY;

typedef struct __ARRAY_NTINT
{
	size_t Size;
	int Num[1];
}ARRAY_NTINT,*PARRAY_NTINT;

//NPC-NPCΨһ
int NPC_Lua_Create(const char *_DoFile, const char *_InitFuncName, char *_seek, BOOL _IsFly);

//ɾNPC NPCΨһ
int NPC_Lua_Del(int _index);

//ս
int NPC_Lua_CreateVsEnemy(lua_State *_NLL, int _CharaIndex, int _NpcIndex, const char *_DoFunc, PCREATEENEMY _CreateEnemy, int _ARLen, int _Flg);

const char *NPC_Lua_SetErrorStr(const char *ErrStr);

//עչýӿ
int NPC_Lua_RegCallEx(lua_State * _NLL, luaL_Reg *_RegList);
//עչӿ
int NPC_Lua_RegLibEx(lua_State * _NLL, PSCRIPTREGLIB _RegLib);
//עչӿ
int NPC_Lua_RegClassEx(lua_State * _NLL, PSCRIPTREGCLASS _RegClass);
//עչӿ
int NPC_Lua_RegArrayEx(lua_State * _NLL, PSCRIPTREGARRAY _RegArray);

//չͽӿں
//NTInt
int NPC_Lua_NTInt_New(lua_State *_NLL);
int NPC_Lua_NTInt_Get(lua_State *_NLL);
int NPC_Lua_NTInt_Set(lua_State *_NLL);
int NPC_Lua_NTInt_Len(lua_State *_NLL);

//ӿں
////////////////////////////////////////////////NL/////////////////////////////////////////////////
int NPC_Lua_NL_GetErrorStr(lua_State *_NLL);						//شϢ
int NPC_Lua_NL_CreateNpc(lua_State *_NLL);							//NPC
int NPC_Lua_NL_DelNpc(lua_State *_NLL);									//ɾNPC
int NPC_Lua_NL_Mod(lua_State *_NLL);									  //
int NPC_Lua_NL_GetStringFromIndexWithDelim(lua_State *_NLL);									//ʹַַָָصָindexλõַ
//int NPC_Lua_NL_ANSI_PlayerLoop(lua_State *_NLL);		    //д
int NPC_Lua_NL_PetLoopGetNext(lua_State *_NLL);		      //дڳس дƶʱ
int NPC_Lua_NL_ItemLoopGetNext(lua_State *_NLL);		    //дڵߣص 
int NPC_Lua_NL_PlayerLoopGetNext(lua_State *_NLL);		  //д 
int NPC_Lua_NL_GetConfigLineType(lua_State *_NLL);	  	//0ΪַΡ1ΪSHORTΡ2ΪINT͡3ΪDOUBLE͡ڸֶΣ-1.
int NPC_Lua_NL_GetConfigLineVal(lua_State *_NLL);	  	  //Ƿ[ַ]ҪתΪ֣tonumber()Ҳֶηnil
BOOL NPC_Lua_CheckNpcEventFree(lua_State *_NLL);									//Ƿĳ
int NPC_Lua_DoNpcEventAction(lua_State *_NLL);									//ִNPCű
int NPC_Lua_NL_SetTimer(lua_State *_NLL);	  	          //趨һʱĺ趨ļʱڵá
int NPC_Lua_NL_DelTimer(lua_State *_NLL);	  	          //ɾһʱһʱɾͲٱڵã
int NPC_Lua_NL_RunSaFuncII(lua_State *_NLL);	  	      //һڶõ2INTĺ
int NPC_Lua_NL_RunSaFuncIII(lua_State *_NLL);	  	      //һڶõ3INTĺ(ITEM_USEʹõߺĻص
int NPC_Lua_NL_ANSI_PlayerLoop(lua_State *_NLL);		    //д
int NPC_Lua_NL_ANSI_PetLoop(lua_State *_NLL);		        //дڳ
int NPC_Lua_NL_ANSI_ItemLoop(lua_State *_NLL);		      //дڵߣ
int NPC_Lua_NL_ClsMk(lua_State *_NLL);
int NPC_Lua_NL_AddCheckNum(lua_State *_NLL);
int NPC_Lua_NL_Mkstring(lua_State *_NLL);
int NPC_Lua_NL_Mkint(lua_State *_NLL);
int NPC_Lua_NL_SendMesg(lua_State *_NLL);

////////////////////////////////////////////////NLG////////////////////////////////////////////////
//ܽӿ
int NPC_Lua_NLG_UpItem(lua_State *_NLL);
int NPC_Lua_NLG_GiveItemOne(lua_State *_NLL);
int NPC_Lua_NLG_GivePetOne(lua_State *_NLL);
int NPC_Lua_NLG_DelItemByIndex(lua_State *_NLL);	
int NPC_Lua_NLG_FindPet(lua_State *_NLL);								//ҳλ
int NPC_Lua_NLG_GetMap(lua_State *_NLL);						    //õǰλõĽ
int NPC_Lua_NLG_PetUp(lua_State *_NLL);								  //
int NPC_Lua_NLG_AddSk(lua_State *_NLL);								  //ְҵ
int NPC_Lua_NLG_SetZy(lua_State *_NLL);								  //趨ְҵ
int NPC_Lua_Char_GetPlayerMaxNum(lua_State *_NLL);			//ȡ
int NPC_Lua_NLG_GetXY(lua_State *_NLL);							  	//ȡһͼ
int NPC_Lua_NLG_WalkJc(lua_State *_NLL);							  //ϰ
int NPC_Lua_NLG_KickPlayer(lua_State *_NLL);				  	//Tָ
int NPC_Lua_NLG_HealOne(lua_State *_NLL);				  	    //ָһ ظHP MP
int NPC_Lua_NLG_HealAll(lua_State *_NLL);				  	    //ָһMP ظаHP
int NPC_Lua_NLG_LevelUpTo(lua_State *_NLL);				  	  //ĵȼ
int NPC_Lua_NLG_AddExp(lua_State *_NLL);			  	  	  //һ顣
int NPC_Lua_NLG_UpPet(lua_State *_NLL);			  	  	    //¶ĳڸ¡ͻˡݣĳЩ̨Ա޸ĵ²ܰѸݷ͵ǰ̨
int NPC_Lua_NLG_DelPetByPos(lua_State *_NLL);						//ɾ  ָλĳ
int NPC_Lua_NLG_DelPetByIndex(lua_State *_NLL);					//ɾ  ָţIDĳ
int NPC_Lua_NLG_GivePetByIndex(lua_State *_NLL);				//һָֻŵĳָ  سλ
int NPC_Lua_NLG_GiveItemByIndex(lua_State *_NLL);				//һindexָ صλ
int NPC_Lua_NLG_WarpToSpecificPoint(lua_State *_NLL);	  //ƶNPC ƶ
BOOL NPC_Lua_NLG_UpSkillupPoint(lua_State *_NLL);       //
int NPC_Lua_NLG_StayEncount(lua_State *_NLL);	          //ԭ

int NPC_Lua_NLG_CheckInFront(lua_State *_NLL);					//ڼĳǷĳǰ
int NPC_Lua_NLG_CheckObj(lua_State *_NLL);							//ĳͼλǷж
int NPC_Lua_NLG_CharLook(lua_State *_NLL);							//﷽(͸·)
int NPC_Lua_NLG_CreateBattle(lua_State *_NLL);					//ս
int NPC_Lua_NLG_InputCard(lua_State *_NLL);							//һԻ⿨
int NPC_Lua_NLG_CreateBattlePvP(lua_State *_NLL);

int NPC_Lua_NLG_SearchWatchBattleRandIndex(lua_State *_NLL);

int NPC_Lua_NLG_DelPet(lua_State *_NLL);								//ɾָҳһ
int NPC_Lua_NLG_DelHaveIndexPet(lua_State *_NLL);
int NPC_Lua_NLG_DelItem(lua_State *_NLL);								//ɾָҵһ
int NPC_Lua_NLG_DelItemByPos(lua_State *_NLL);								//ɾָҵһ
int NPC_Lua_NLG_DischargeParty(lua_State *_NLL);				//ɢ Ŷ

int NPC_Lua_NLG_GivePet(lua_State *_NLL);								//ָһ
int NPC_Lua_NLG_GiveOnePet(lua_State *_NLL);								//ָһ
int NPC_Lua_NLG_GiveItem(lua_State *_NLL);							//ָһ
int NPC_Lua_NLG_GiveOneItem(lua_State *_NLL);							//ָһ
int NPC_Lua_NLG_GiveRandItem(lua_State *_NLL);
int NPC_Lua_Char_GetOnLinePlayer(lua_State *_NLL);			//ȡǰ

int NPC_Lua_NLG_ShowWindowTalked(lua_State *_NLL);			//ָҿͻʾָݡ͵ĶԻ
int NPC_Lua_NLG_SetAction(lua_State *_NLL);							//öĶ

int NPC_Lua_NLG_TalkToCli(lua_State *_NLL);							//ͨ˵Զȫ˵
int NPC_Lua_NLG_TalkToFloor(lua_State *_NLL);						//ĳһָͼڵ˵

int NPC_Lua_NLG_UpChar(lua_State *_NLL);								//NPCΧҷNPCݸ·
int NPC_Lua_NLG_UpStateBySecond(lua_State *_NLL);				//ָҷ͵2״̬·
int NPC_Lua_NLG_UpStateByThird(lua_State *_NLL);				//ָҷ͵3״̬·
int NPC_Lua_NLG_Update_Party(lua_State *_NLL);					//ڵŶӳԱҵ״̬·

int NPC_Lua_NLG_Warp(lua_State *_NLL);									//һ
int NPC_Lua_NLG_WalkMove(lua_State *_NLL);							//ƶһ
int NPC_Lua_NLG_WatchEntry(lua_State *_NLL);						//ս
int NPC_Lua_NLG_HealerAllHeal(lua_State *_NLL);         //Ѫ
int NPC_Lua_NLG_GetMaxPlayNum(lua_State *_NLL);					//ȡ
int NPC_Lua_NLG_CheckPlayIndex(lua_State *_NLL);				//Ƿ
int NPC_Lua_NLG_Save(lua_State *_NLL);
////add by mo
int NPC_Lua_NLG_SetExp(lua_State *_NLL);							//÷鱶
int NPC_Lua_NLG_GetExp(lua_State *_NLL);							//ȡ鱶
#ifdef _PETTRANS_RANGE
int NPC_Lua_NLG_SetPetTransRange(lua_State *_NLL);				//óתΧ
int NPC_Lua_NLG_GetPetTransRange(lua_State *_NLL);				//óתΧ
#endif
///////////////////////////////////////////////Char////////////////////////////////////////////////
//ݵĽӿ
int NPC_Lua_Char_ClrEvtEnd(lua_State *_NLL);						//־
int NPC_Lua_Char_ClrEvtNow(lua_State *_NLL);						//־
int NPC_Lua_Char_ClrEvt(lua_State *_NLL);								//־
int NPC_Lua_Char_GetAllocPoint(lua_State *_NLL);	      //ȡCharIndexάɳ
int NPC_Lua_Char_GetDataFromEnemyBase(lua_State *_NLL);	//ȡӦ ־ ĳģݣenemybaseX.txt
int NPC_Lua_Char_GetPlayerIndex(lua_State *_NLL);       //
int NPC_Lua_Char_FindItemIndex(lua_State *_NLL);				//ָǷӵĳΪָ
int NPC_Lua_Char_FindPetIndex(lua_State *_NLL);		      //ָǷӵгΪָ
int NPC_Lua_CHAR_CHECKINDEX(lua_State *_NLL);				     //
int NPC_Lua_Char_GetPetSkill(lua_State *_NLL);				  //ȡóָļܱ
int NPC_Lua_Char_GetPetSkillNo(lua_State *_NLL);	      //ȡChar
int NPC_Lua_Char_RidNo(lua_State *_NLL);								//־
int NPC_Lua_Char_GetEmptyItemBoxNum(lua_State *_NLL);	  //ָϵλ
int NPC_Lua_Char_GetEmptyPetBoxNum(lua_State *_NLL);	  //ָϳλ
int NPC_Lua_Char_GetPlayerItemNum(lua_State *_NLL);	    //ָΪĳIDĵߵ
int NPC_Lua_Char_GetPlayerPetNum(lua_State *_NLL);	    //ָΪĳIDĳ
int NPC_ABLua_char_getPlayerMaxNum(lua_State *_NLL);    //
int NPC_ABLua_char_getBattleexp(lua_State *_NLL);       //ս鱶
int NPC_Lua_Char_SetPetSkill(lua_State *_NLL);				  //óָļܱ
int NPC_Lua_Char_SetPetSkillNo(lua_State *_NLL);	
int NPC_Lua_Char_ComplianceParameter(lua_State *_NLL);	//ݶ¼㲢WORKԣԴﵽЧĿġ
int NPC_Lua_Char_HcItemId(lua_State *_NLL);					  	//ϳõϷƷ
int NPC_Lua_Char_DelHcItem(lua_State *_NLL);					  //ɾĳλõƷ
int NPC_Lua_Char_GETFM(lua_State *_NLL);					      //ȡ  ʽ
int NPC_Lua_Char_FindPetEnemyBaseId(lua_State *_NLL);		//ָǷӵгEnemyBaseļĶӦID
int NPC_Lua_Char_ITEMID_NAME(lua_State *_NLL);					//ָID
int NPC_Lua_Char_ITEMID_NAME2(lua_State *_NLL);					//ָID˵
int NPC_Lua_Char_ITEMID_LEVEL(lua_State *_NLL);					//ָIDĵȼ
int NPC_Lua_Char_ITEMID_GOLD(lua_State *_NLL);					//ָIDļ۸
int NPC_Lua_Char_ITEMID_RANO(lua_State *_NLL);					//ָIDͼ
//int NPC_Lua_Char_CharRidNo(lua_State *_NLL);					  //ǷѾĳ֤
int NPC_Lua_Char_GetPetOwner(lua_State *_NLL);				  //ó˵
int NPC_Lua_Char_GetEnemyBaseIdFromEnemyId(lua_State *_NLL);	//ͨenemy.txtõĳenemybase.txt趨ĳš
int NPC_Lua_Char_GetEnemyIdFromEnemyBaseId(lua_State *_NLL);	//ͨenemybase.txtõĳenemy.txt趨ĳš
int NPC_Lua_Char_GetIp(lua_State *_NLL);	              //ȡָIPַ
int NPC_Lua_Char_SetAllocPoint(lua_State *_NLL);	      //óCharIndexάɳ
int NPC_Lua_Char_GetMaxPetIndex(lua_State *_NLL);	      //ȡ
int NPC_Lua_Char_GetMaxPlayerIndex(lua_State *_NLL);	  //ȡ
int NPC_Lua_Char_SavePetToString(lua_State *_NLL);	    //һַ
int NPC_Lua_Char_LoadPetFromString(lua_State *_NLL);	  //һַһ
int NPC_Lua_Char_GetPlayerFromAccAndName(lua_State *_NLL);//ҵʺźѰҡʺźҲɲҡɶ
int NPC_Lua_Char_CheckPet(lua_State *_NLL);             //ǷЧ
int NPC_Lua_Char_CheckPlayer(lua_State *_NLL);          //ǷЧ
BOOL NPC_Lua_Char_JoinParty(lua_State *_NLL);           //Ŷ
int NPC_Lua_Char_getFamilyPlayIndex(lua_State *_NLL);   //ü

int NPC_Lua_Char_SetEvtEnd(lua_State *_NLL);						//־Ϊ״̬
int NPC_Lua_Char_SetEvtNow(lua_State *_NLL);						//־Ϊ״̬
int NPC_Lua_Char_SetData(lua_State *_NLL);							//Char

int NPC_Lua_Char_getVipPoint(lua_State *_NLL);          //Ա
int NPC_Lua_Char_getjfPoint(lua_State *_NLL);           //ָ
int NPC_Lua_Char_getxjPoint(lua_State *_NLL);           //ֽ
int NPC_Lua_Char_setVipPoint(lua_State *_NLL);          //Ա
int NPC_Lua_Char_setjfPoint(lua_State *_NLL);           //ֲ
int NPC_Lua_Char_setxjPoint(lua_State *_NLL);           //ֽ

//¼õĽӿ
int NPC_Lua_Char_SetWalkPreEvent(lua_State *_NLL);			//WalkPre¼Ӧ
int NPC_Lua_Char_SetWalkPostEvent(lua_State *_NLL);			//WalkPost¼Ӧ
int NPC_Lua_Char_SetPreOverEvent(lua_State *_NLL);			//PreOver¼Ӧ
int NPC_Lua_Char_SetPostOverEvent(lua_State *_NLL);			//PostOver¼Ӧ
int NPC_Lua_Char_SetWatchEvent(lua_State *_NLL);				//Watch¼Ӧ
int NPC_Lua_Char_SetLoopEvent(lua_State *_NLL);					//Loop¼Ӧ
int NPC_Lua_Char_SetTalkedEvent(lua_State *_NLL);				//Talked¼Ӧ
int NPC_Lua_Char_SetOFFEvent(lua_State *_NLL);					//OFF¼Ӧ
int NPC_Lua_Char_SetLookedEvent(lua_State *_NLL);				//Looked¼Ӧ
int NPC_Lua_Char_SetItemPutEvent(lua_State *_NLL);			//ItemPut¼Ӧ
int NPC_Lua_Char_SetWindowTalkedEvent(lua_State *_NLL);	//WindowTalked¼Ӧ
#ifdef _USER_CHARLOOPS
int NPC_Lua_Char_SetCharLoopsEvent(lua_State *_NLL);		//CharLoops¼Ӧ
int NPC_Lua_Char_SetBattleProPertyEvent(lua_State *_NLL);//BattleProPerty¼Ӧ
#endif

//ȡݵĽӿ
int NPC_Lua_Char_IsEventEnd(lua_State *_NLL);						//Ƿ־
int NPC_Lua_Char_IsEventNow(lua_State *_NLL);						//Ƿ־

int NPC_Lua_Char_FindItemId(lua_State *_NLL);						//ָǷӵĳID
int NPC_Lua_Char_FindPetEnemyId(lua_State *_NLL);				//ָǷӵгEnemyļĶӦID

int NPC_Lua_Char_GetData(lua_State *_NLL);						//ȡChar
int NPC_Lua_Char_GetItemId(lua_State *_NLL);						//ȡָָλõĵID
int NPC_Lua_Char_GetPetEnemyId(lua_State *_NLL);				//ȡָָλõĳEnemyļĶӦID
int NPC_Lua_Char_GetItemIndex(lua_State *_NLL);					//ȡָָλõĵ
int NPC_Lua_Char_GetPetIndex(lua_State *_NLL);					//ȡָָλõĳ
int NPC_Lua_Char_GetTeamIndex(lua_State *_NLL);					//ȡԱĶ
int NPC_Lua_Char_GetPlayerIndexByCdkey(lua_State *_NLL);		//ͨʺŲѯ
int NPC_Lua_Char_VipPoint(lua_State *_NLL);
int NPC_Lua_Char_HealAll(lua_State *_NLL);
int NPC_Lua_Char_GetPetSkillId(lua_State *_NLL);
int NPC_Lua_Char_GetPetSkillName(lua_State *_NLL);
int NPC_Lua_Char_GetPetSkillMsg(lua_State *_NLL);
int NPC_Lua_Char_SetPetSkill(lua_State *_NLL);
int NPC_Lua_Char_RandMsg(lua_State *_NLL);
int NPC_Lua_Char_GetBeatitudeNum(lua_State *_NLL);
///////////////////////////////////////////////GAME////////////////////////////////////////////////
int NPC_Lua_Game_FMPOINT_GetData(lua_State *_NLL);           //ׯ԰ݵϢ
int NPC_Lua_Game_FMPOINT_ACSetFMPoint(lua_State *_NLL);      //趨ݵϢݵδռʱЧ
int NPC_Lua_Game_FMPOINT_ACFixFMPoint(lua_State *_NLL);      //޸ļݵϢơһս
int NPC_Lua_Game_FMPOINT_ACCleanFMPoint(lua_State *_NLL);    //ݵ㡣
///////////////////////////////////////////////Item////////////////////////////////////////////////
//ȡݵĽӿ
int NPC_Lua_Item_GetData(lua_State *_NLL);							//ȡ
int NPC_Lua_Item_GetDataFromItemSet(lua_State *_NLL);		//ȡITEMSETXļ
//ݵĽӿ
int NPC_Lua_Item_SetData(lua_State *_NLL);							//ȡ

//¼õĽӿ
int NPC_Lua_Item_SetPreOverEvent(lua_State *_NLL);			//PreOver¼Ӧ
int NPC_Lua_Item_SetPostOverEvent(lua_State *_NLL);			//PostOver¼Ӧ
int NPC_Lua_Item_SetWatchEvent(lua_State *_NLL);				//Watch¼Ӧ
int NPC_Lua_Item_SetUseEvent(lua_State *_NLL);					//Use¼Ӧ
int NPC_Lua_Item_SetAttachEvent(lua_State *_NLL);				//Attach¼Ӧ
int NPC_Lua_Item_SetDetachEvent(lua_State *_NLL);				//Detach¼Ӧ
int NPC_Lua_Item_SetDropEvent(lua_State *_NLL);					//Drop¼Ӧ
int NPC_Lua_Item_SetPickUPEvent(lua_State *_NLL);				//PickUP¼Ӧ
#ifdef _Item_ReLifeAct
int NPC_Lua_Item_SetDieReLifeEvent(lua_State *_NLL);		//DieReLife¼Ӧ
#endif
///////////////////////////////////////////////BIT///////////////////////////////////////////////
int NPC_Lua_Bit_band(lua_State *_NLL);
int NPC_Lua_Bit_bor(lua_State *_NLL);
int NPC_Lua_Bit_bxor(lua_State *_NLL);
int NPC_Lua_Bit_lshift(lua_State *_NLL);
int NPC_Lua_Bit_rshift(lua_State *_NLL);
///////////////////////////////////////////////Obj////////////////////////////////////////////////
//ȡݵĽӿ
int NPC_Lua_Obj_GetType(lua_State *_NLL);								//ȡOBJ
/*
int NPC_Lua_Obj_GetName(lua_State *_NLL);								//ȡOBJ
int NPC_Lua_Obj_GetDIR(lua_State *_NLL);								//ȡOBJķ
int NPC_Lua_Obj_GetImageNum(lua_State *_NLL);						//ȡOBJ
*/
int NPC_Lua_Obj_GetCharType(lua_State *_NLL);						//ȡOBJӦCharݽṹ
int NPC_Lua_Obj_GetCharIndex(lua_State *_NLL);					//ȡOBJӦCharݽṹ
int NPC_Lua_Obj_GetX(lua_State *_NLL);									//ȡOBJX
int NPC_Lua_Obj_GetY(lua_State *_NLL);									//ȡOBJY
int NPC_Lua_Obj_GetFloor(lua_State *_NLL);							//ȡOBJڵĵͼ
//int NPC_Lua_Obj_GetDelTime(lua_State *_NLL);						//ȡOBJɾʱ

int NPC_Lua_Obj_SetType(lua_State *_NLL);								//ȡOBJ
/*
int NPC_Lua_Obj_SetName(lua_State *_NLL);								//ȡOBJ
int NPC_Lua_Obj_SetDIR(lua_State *_NLL);								//ȡOBJķ
int NPC_Lua_Obj_SetImageNum(lua_State *_NLL);						//ȡOBJ
*/
int NPC_Lua_Obj_SetCharType(lua_State *_NLL);						//ȡOBJӦCharݽṹ
int NPC_Lua_Obj_SetX(lua_State *_NLL);									//ȡOBJX
int NPC_Lua_Obj_SetY(lua_State *_NLL);									//ȡOBJY
int NPC_Lua_Obj_SetFloor(lua_State *_NLL);							//ȡOBJڵĵͼ
//int NPC_Lua_Obj_SetDelTime(lua_State *_NLL);						//ȡOBJɾʱ

//////////////////////////////////////////////Battle///////////////////////////////////////////////
//ȡݵĽӿ
int NPC_Lua_Battle_GetPlayIndex(lua_State *_NLL);				//ȡսе
int NPC_Lua_Battle_GetData(lua_State *_NLL);				    //ȡս
int NPC_Lua_Battle_SetData(lua_State *_NLL);				    //ս
int NPC_Lua_Battle_IndexToNo(lua_State *_NLL);				  //ͨȡڵս
int NPC_Lua_Battle_NoToIndex(lua_State *_NLL);				  //ͨսŻȡ
int NPC_Lua_Battle_CheckIndex(lua_State *_NLL);				  //սǷЧ
//ݵĽӿ
int NPC_Lua_Battle_SetNORisk(lua_State *_NLL);					//Ƿ޷ģʽ
int NPC_Lua_Battle_SetMod(lua_State *_NLL);							//սģʽ־
int NPC_Lua_Battle_SetType(lua_State *_NLL);						//ս
int NPC_Lua_Battle_Exit(lua_State *_NLL);				        //˳ս
//¼õĽӿ
int NPC_Lua_Battle_SetWinEvent(lua_State *_NLL);				//Win¼Ӧ
int NPC_Lua_Battle_SetEndEvent(lua_State *_NLL);				//Win¼Ӧ
///////////////////////////////////////////////Other///////////////////////////////////////////////
int NPC_Lua_GetFuncPoint(lua_State *_NLL);							//ȡָ

//////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////MAP////////////////////////////////////////////////
int NPC_Lua_Map_CheckCoordinates(lua_State *_NLL);         //ĳǷڵͼΧڡ
int NPC_Lua_Map_GetExitFloorXY(lua_State *_NLL);           //ͼǷֵ֧ǳ
int NPC_Lua_Map_GetfloorX(lua_State *_NLL);                //ȡͼX
int NPC_Lua_Map_GetfloorY(lua_State *_NLL);                 //ȡͼY
int NPC_Lua_Map_GetTileAndObjId(lua_State *_NLL);           //ȡͼĳĵذװβ
int NPC_Lua_Map_SetTileAndObjId(lua_State *_NLL);           //õͼĳĵذװβ
int NPC_Lua_Map_GetWalkAbleFromPoint(lua_State *_NLL);      //ȡĳǷ
int NPC_Lua_Map_GetImageData(lua_State *_NLL);              //ȡͼƬ
int NPC_Lua_Map_SetImageData(lua_State *_NLL);              //ͼƬ
int NPC_Lua_Map_GetTopObj(lua_State *_NLL);                 //ȡͼĳ϶
int NPC_Lua_Map_GetNextObj(lua_State *_NLL);                //ȡһ
int NPC_Lua_Map_CheckImageIndex(lua_State *_NLL);           //ĳͼͼƬǷ
int NPC_Lua_Map_CheckIndex(lua_State *_NLL);                //ĳͼŵͼǷ
int NPC_Lua_Map_MakeNewMap(lua_State *_NLL);                //һµĵͼ صͼID
int NPC_Lua_Map_DelNewMap(lua_State *_NLL);                 //ɾһͼ
int NPC_Lua_Map_SetExWarp(lua_State *_NLL);                 //ǳͼĴ͵
int NPC_Lua_Map_SetMapPoint(lua_State *_NLL);               //ӵͼ͵
int NPC_Lua_Map_DelMapPoint(lua_State *_NLL);               //ɾͼ͵
int NPC_Lua_Map_getFloorName(lua_State *_NLL);               //õͼ
int NPC_Lua_Map_Upmap(lua_State *_NLL);                      //µͼ
///////////////////////////////////////////////MAP////////////////////////////////////////////////
///////////////////////////////////////////////Spell////////////////////////////////////////////////
int NPC_Lua_Spell_PETSKILL_GetData(lua_State *_NLL);    //ȡ＼ID
int NPC_Lua_Spell_PROFESSION_GetData(lua_State *_NLL);  //ȡְҵID
int NPC_Lua_Spell_MAGIC_GetData(lua_State *_NLL);       //ȡ鼼ID
int NPC_Lua_Spell_PETSKILL_SetData(lua_State *_NLL);    //öӦIDļݣ
int NPC_Lua_Spell_PROFESSION_SetData(lua_State *_NLL);  //öӦIDļݣ
int NPC_Lua_Spell_MAGIC_SetData(lua_State *_NLL);       //öӦIDļݣ
///////////////////////////////////////////////Spell////////////////////////////////////////////////
///////////////////////////////////////////////SQL/////////////////////////////////////////////////
int NPC_Lua_SQL_Push(lua_State *_NLL);						//MySQLָ
int NPC_Lua_SQL_PushPop(lua_State *_NLL);			//MySQLָӦ
int NPC_Lua_SQL_PushPopAdv(lua_State *_NLL);            //SAACһSQLѯ󣬲ָSAACشʱԽдĻص,úصһнͷŽ
int NPC_Lua_SQL_QueryFirstRow(lua_State *_NLL);         //ص,úصһнͷŽ
int NPC_Lua_SQL_FetchRow(lua_State *_NLL);              //һ
int NPC_Lua_SQL_FreeResult(lua_State *_NLL);            //ͷŽ
///////////////////////////////////////////////SQL///////////////////////////////////////////////
#define LRet(r) \
{ \
	NPC_Lua_SetErrorStr(NULL); \
	return r; \
}

#define LRetErr(c,r) \
{ \
	NPC_Lua_SetErrorStr(c); \
	return r; \
}

//////////////////////////////////////////////////////////////////////
//һnil
#define LRetNull(L) \
{ \
	lua_pushnil(L); \
	LRet(1); \
}

//һBOOLLUA
#define LRetBool(L, b) \
{ \
	lua_pushboolean(L, b); \
	LRet(1); \
}

//һintLUA
#define LRetInt(L, i) \
{ \
	lua_pushinteger(L, i); \
	LRet(1); \
}

#define LRetMsg(L, c) \
{ \
	lua_pushstring(L, c); \
	LRet(1); \
}
////////////////////////////////////////////////////////////////////
//һ״̬һϢ
#define LRetErrInt(L, i, c) \
{ \
	lua_pushinteger(L, i); \
	LRetErr(c,1); \
}

//һַLUA
#define LRetErrNull(L, c) \
{ \
	lua_pushnil(L); \
	LRetErr(c,1); \
}

//һַLUA
#define LRetErrMsg(L, c) \
{ \
	lua_pushstring(L, c); \
	LRetErr(c,1); \
}

//ڼǷ㹻
#define CheckEx(L, n) \
{	\
	if(lua_gettop(L) != n) \
	{ \
		luaL_argerror(L, 1, ""); \
	} \
}

#define CheckEx2(L, t, n) \
{	\
	if(lua_gettop(L) < (t) || lua_gettop(L) > n) \
	{ \
		luaL_argerror(L, 1, ""); \
	} \
}

#define CheckIndexNull(L, n) \
{ \
	if(lua_isnil((L), (n))) \
	{ \
		luaL_argerror((L), 1, "Ϊnil"); \
	} \
}

#define CheckBattleIndexNull(L, n) \
{ \
	if(lua_isnil((L), (n))) \
	{ \
		luaL_argerror((L), 1, "սΪnil"); \
	} \
}

#define CheckItemIndexNull(L, n) \
{ \
	if(lua_isnil((L), (n))) \
	{ \
		luaL_argerror((L), 1, "Ϊnil"); \
	} \
}

#define CheckObjIndexNull(L, n) \
{ \
	if(lua_isnil((L), (n))) \
	{ \
		luaL_argerror((L), 1, "Ϊnil"); \
	} \
}

#define LRetArray(L, Array, num) \
{ \
	Lua_ReturnArray(L, Array, num); \
	LRet(1); \
}

#ifdef _LUA_Debug
int pcall_callback_err_fun(lua_State* L,const char *_InitFuncName); //LUAűϢ
#endif

#endif //#ifndef __NPC_LUA__
